package com.jiuqi.syntax;

import java.util.HashMap;
import java.util.ArrayList;

public final class Functions extends ArrayList
{
    private HashMap hashFunctions;
    
    public Functions() {
        this.hashFunctions = new HashMap();
    }
    
    public Function getFunc(final int index) {
        return super.get(index);
    }
    
    public Function getFunc(final String name) {
        return this.hashFunctions.get(name.toUpperCase());
    }
    
    public boolean exists(final String name) {
        return this.hashFunctions.get(name.toUpperCase()) != null;
    }
    
    @Override
    public boolean add(final Object obj) {
        final boolean b = super.add(obj);
        if (b) {
            this.hashFunctions.put(((Function)obj).name.toUpperCase(), obj);
        }
        return b;
    }
    
    public boolean add(final Function func) {
        return this.add((Object)func);
    }
    
    public Function addFunc(final String name, final String title) {
        return this.addFunc(name, title, "", 0);
    }
    
    public Function addFunc(final String name, final String title, final String description, final int resultType) {
        final Function func = new Function();
        func.name = name;
        func.title = title;
        func.description = description;
        func.resultType = resultType;
        if (this.add(func)) {
            return func;
        }
        return null;
    }
    
    @Override
    public Object remove(final int index) {
        final Object obj = super.remove(index);
        if (obj != null) {
            this.hashFunctions.remove(((Function)obj).name.toUpperCase());
        }
        return obj;
    }
}
